# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob
import zipfile


def update_package():
    # Declaring local variables
    package_updated = False

    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    # Get the page content
    url = "https://the-sz.com/products/doro/"
    response = requests.get(url, proxies=proxies)
    html_content = response.text

    # Use bs_find_all to extract the data-original-title attribute
    links = bs_find_all(html_content, "a", "class", "download-link", proxies=proxies)

    version = None
    for link in links:
        # Extract data-original-title attribute
        data_original_title = link.get("title", "")

        if "Version" in data_original_title:
            # Extract the version from data-original-title
            version = data_original_title.split("Version ")[-1].split(" · ")[0]  # Extract version number
            print(f"Found version: {version}")
            break

    url = requests.head("https://the-sz.com/common/get.php?product=doro", allow_redirects=True, proxies=proxies)
    download_url = url.url
    latest_bin = download_url.split("/")[-1]

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)

    # Deleting outdated binaries
    for f in glob.glob("*.zip"):
        if f != latest_bin:
            remove_file(f)

    # Extracting the .exe file from the .zip archive
    with zipfile.ZipFile(latest_bin, "r") as zip_ref:
        zip_ref.extractall()

        exe_file = None
        for file in zip_ref.namelist():
            if file.endswith(".exe"):
                exe_file = file
                print(f"Extracted {exe_file}")
                break

    # Mettre à jour le package
    control.set_software_version(version)
    control.save_control_to_wapt()
